<template>
    <div class="login-box">
            <div class="login-logo">
            <div><img src="/img/logo.png"/></div>
        </div>
        <div class="card">
            <div class="card-body login-card-body">
                <div class="alert alert-danger"  v-if="error">
                    <strong>{{ error }}</strong>
                </div>
                <p class="login-box-msg">
                    For security reasons, system passwords are encrypted and can not be displayed.<br><br>
                    Therefore, if you forgot your password, you must enter your registered email and we 
                    will send you a link to reset it.
                </p>
                <form ref="form">
                    <div class="form-group">
                        <label for="email">E-mail</label>
                        <div class="input-group mb-3">
                            <input id="email" type="email" class="form-control" name="email" 
                                   v-model="email" required autofocus
                                   v-bind:class="{ 'is-invalid': errors.email }">
                            <div class="input-group-append">
                                <div class="input-group-text">
                                    <span class="fas fa-envelope"></span>
                                </div>
                            </div>
                            <span class="invalid-feedback" role="alert" v-if="errors.email !== null">
                                <strong v-for="msg in errors.email">{{ msg }}</strong>
                            </span>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-12">
                            <button type="submit" class="btn btn-primary btn-block" v-on:click.prevent="resetPassword">
                                Request new password
                            </button>
                        </div>
                    </div>
                </form>
                <p class="mt-3 mb-1">
                    <router-link to="/login">Login</router-link>
                </p>
            </div>
        </div>
    </div>
</template>

<script>
import FormMixin from '../../mixins/FormMixin.vue';
import settings from '../../settings.js';

export default {
    mixins: [FormMixin],
    data() {
        return {
            email: '',
            password: '',
            error: null,
            errors: {
                email: null
            }
        };
    },
    created() {
        $('body').addClass('login-page');
    },
    methods: {
        resetPassword() {
            this.error = null;
            if (!this.isValidForm()) {
                return;
            }
            var vm = this;
            var data = {
                email: this.email
            };
            var onError = function(error) {
                vm.error = error.response.data.message;
            };
            this.save('post', '/password/email', data, {
                onError
            });
        }
    },
    mounted() {
        document.head.querySelector('title').text = "Recover password" + " - " + settings.title;
    }
}
</script>